package com.sun.org.apache.xerces.internal.dom;

import java.util.List;
import java.util.ArrayList;
import org.w3c.dom.DOMImplementationList;
import com.sun.org.apache.xerces.internal.impl.xs.XSImplementationImpl;
import org.w3c.dom.DOMImplementation;

public class DOMXSImplementationSourceImpl extends DOMImplementationSourceImpl
{
    public DOMXSImplementationSourceImpl() {
    }
    
    @Override
    public DOMImplementation getDOMImplementation(String features) {
        DOMImplementation impl = super.getDOMImplementation(features);
        if (impl != null) {
            return impl;
        }
        impl = PSVIDOMImplementationImpl.getDOMImplementation();
        if (this.testImpl(impl, features)) {
            return impl;
        }
        impl = XSImplementationImpl.getDOMImplementation();
        if (this.testImpl(impl, features)) {
            return impl;
        }
        return null;
    }
    
    @Override
    public DOMImplementationList getDOMImplementationList(String features) {
        List<DOMImplementation> implementations = new ArrayList();
        DOMImplementationList list = super.getDOMImplementationList(features);
        for (int i = 0; i < list.getLength(); ++i) {
            implementations.add(list.item(i));
        }
        DOMImplementation impl = PSVIDOMImplementationImpl.getDOMImplementation();
        if (this.testImpl(impl, features)) {
            implementations.add(impl);
        }
        impl = XSImplementationImpl.getDOMImplementation();
        if (this.testImpl(impl, features)) {
            implementations.add(impl);
        }
        return new DOMImplementationListImpl(implementations);
    }
}
